import type { BundledTheme } from 'shiki';
import type { ThemeRegistration } from 'shiki';

declare type Highlight_2 = (
	code: string,
	lang: string,
	opts: {
    		inlineCode: boolean;
    		theme?: PluginOptions['theme'];
    		themes?: PluginOptions['themes'];
    		spaceSubstitution?: boolean;
    		loadThemes?: PluginOptions['loadThemes'];
    	} = {}
) => Promise<string>;
export { Highlight_2 as Highlight }

export declare type HighlightInline = (
	code,
	lang,
	opts: {
    		theme?: PluginOptions["theme"];
    	} = {}
) => Promise<string>;

export declare type LiteralUnion<T extends U, U = string> = T | (U & { zz_IGNORE_ME?: never });

export declare interface PluginOptions {
    	theme?: LiteralUnion<BundledTheme>;
    	themes?: Record<string, string>;
    	loadThemes?: Record<string, ThemeRegistration>
    	inlineCode?: {
        		spaceSubstitution?: boolean;
        		theme?: PluginOptions["theme"];
        	};
}

export { }
