import { visitParents as P, SKIP as N, CONTINUE as $ } from "unist-util-visit-parents";
import { getHighlighter as q, bundledThemes as T } from "shiki";
import { parseFragment as A } from "parse5";
import { fromParse5 as C } from "hast-util-from-parse5";
const E = async (e, n, t = {
  theme: "dracula",
  inlineCode: !1
}) => {
  var i, s;
  const r = await q({ langs: [n], themes: [] });
  if (t.theme && Object.keys(T).includes(t.theme))
    await r.loadTheme(t.theme);
  else if (t.loadThemes && t.theme && Object.keys(t.loadThemes).includes(t.theme)) {
    const c = t.loadThemes[t.theme];
    c.name = t.theme, await r.loadTheme(c);
  }
  if (t.themes && typeof t.themes == "object")
    for (const c in t.themes)
      Object.keys(T).includes(t.themes[c]) ? await r.loadTheme(t.themes[c]) : console.log(c);
  const o = {
    lang: n,
    transformers: []
  };
  return typeof t.theme == "string" ? o.theme = t.theme : o.themes = t.theme, t.inlineCode && ((i = o.transformers) == null || i.push({
    name: "rehype-highlighter-inline-code",
    code: function(c) {
      c.properties.class = c.properties.class || "", this.pre.properties && this.pre.properties.class && c.properties && (c.properties.class = c.properties.class + this.pre.properties.class.toString()), c.properties["data-rh-highlighter-inline"] = !0;
    }
  }), t.spaceSubstitution && ((s = o.transformers) == null || s.push({
    name: "rehype-highlighter-space-substitution",
    code: function(c) {
      P(c, "text", function(l) {
        l.value = l.value.replace(/\s/g, "&nbsp;");
      });
    }
  }))), r.codeToHtml(e, o);
}, j = (e) => {
  const t = /^(?<escaped>\s*):(?<token>[\w-]+):(?<content>[\w+\s\S]*)/gm.exec(e);
  if (!t)
    return e;
  const { groups: r } = t, { escaped: o, token: i, content: s } = r;
  if (o.length)
    o.length >= 1;
  else
    return { token: i, content: s };
  return e.substring(1);
}, D = (e) => {
  const { className: n } = e.properties;
  let t = "";
  for (const r of n)
    if (r.startsWith("language-")) {
      t = r.slice(9);
      break;
    }
  return t;
}, L = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return z;
    if (typeof e == "function")
      return g(e);
    if (typeof e == "object")
      return Array.isArray(e) ? U(e) : V(e);
    if (typeof e == "string")
      return Y(e);
    throw new Error("Expected function, string, or object as test");
  }
);
function U(e) {
  const n = [];
  let t = -1;
  for (; ++t < e.length; )
    n[t] = L(e[t]);
  return g(r);
  function r(...o) {
    let i = -1;
    for (; ++i < n.length; )
      if (n[i].apply(this, o))
        return !0;
    return !1;
  }
}
function V(e) {
  const n = (
    /** @type {Record<string, unknown>} */
    e
  );
  return g(t);
  function t(r) {
    const o = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      r
    );
    let i;
    for (i in e)
      if (o[i] !== n[i])
        return !1;
    return !0;
  }
}
function Y(e) {
  return g(n);
  function n(t) {
    return t && t.type === e;
  }
}
function g(e) {
  return n;
  function n(t, r, o) {
    return !!(G(t) && e.call(
      this,
      t,
      typeof r == "number" ? r : void 0,
      o || void 0
    ));
  }
}
function z() {
  return !0;
}
function G(e) {
  return e !== null && typeof e == "object" && "type" in e;
}
const I = (
  // Note: overloads like this are needed to support optional generics.
  /**
   * @type {(
   *   (<Kind extends UnistParent, Check extends Test>(parent: Kind, index: Child<Kind> | number, test: Check) => Matches<Child<Kind>, Check> | undefined) &
   *   (<Kind extends UnistParent>(parent: Kind, index: Child<Kind> | number, test?: null | undefined) => Child<Kind> | undefined)
   * )}
   */
  /**
   * @param {UnistParent} parent
   * @param {UnistNode | number} index
   * @param {Test} [test]
   * @returns {UnistNode | undefined}
   */
  function(e, n, t) {
    const r = L(t);
    if (!e || !e.type || !e.children)
      throw new Error("Expected parent node");
    if (typeof n == "number") {
      if (n < 0 || n === Number.POSITIVE_INFINITY)
        throw new Error("Expected positive finite number as index");
    } else if (n = e.children.indexOf(n), n < 0)
      throw new Error("Expected child node or index");
    for (; ++n < e.children.length; )
      if (r(e.children[n], n, e))
        return e.children[n];
  }
), p = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends TestFunction>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & Predicate<Condition, Element>) &
   *   (<Condition extends string>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & {tagName: Condition}) &
   *   ((test?: null | undefined) => (element?: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test | null | undefined} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return Q;
    if (typeof e == "string")
      return M(e);
    if (typeof e == "object")
      return J(e);
    if (typeof e == "function")
      return k(e);
    throw new Error("Expected function, string, or array as `test`");
  }
);
function J(e) {
  const n = [];
  let t = -1;
  for (; ++t < e.length; )
    n[t] = p(e[t]);
  return k(r);
  function r(...o) {
    let i = -1;
    for (; ++i < n.length; )
      if (n[i].apply(this, o))
        return !0;
    return !1;
  }
}
function M(e) {
  return k(n);
  function n(t) {
    return t.tagName === e;
  }
}
function k(e) {
  return n;
  function n(t, r, o) {
    return !!(X(t) && e.call(
      this,
      t,
      typeof r == "number" ? r : void 0,
      o || void 0
    ));
  }
}
function Q(e) {
  return !!(e && typeof e == "object" && "type" in e && e.type === "element" && "tagName" in e && typeof e.tagName == "string");
}
function X(e) {
  return e !== null && typeof e == "object" && "type" in e && "tagName" in e;
}
const O = /\n/g, S = /[\t ]+/g, x = p("br"), F = p(oe), Z = p("p"), B = p("tr"), ee = p([
  // List from: <https://html.spec.whatwg.org/multipage/rendering.html#hidden-elements>
  "datalist",
  "head",
  "noembed",
  "noframes",
  "noscript",
  // Act as if we support scripting.
  "rp",
  "script",
  "style",
  "template",
  "title",
  // Hidden attribute.
  ie,
  // From: <https://html.spec.whatwg.org/multipage/rendering.html#flow-content-3>
  se
]), v = p([
  "address",
  // Flow content
  "article",
  // Sections and headings
  "aside",
  // Sections and headings
  "blockquote",
  // Flow content
  "body",
  // Page
  "caption",
  // `table-caption`
  "center",
  // Flow content (legacy)
  "dd",
  // Lists
  "dialog",
  // Flow content
  "dir",
  // Lists (legacy)
  "dl",
  // Lists
  "dt",
  // Lists
  "div",
  // Flow content
  "figure",
  // Flow content
  "figcaption",
  // Flow content
  "footer",
  // Flow content
  "form,",
  // Flow content
  "h1",
  // Sections and headings
  "h2",
  // Sections and headings
  "h3",
  // Sections and headings
  "h4",
  // Sections and headings
  "h5",
  // Sections and headings
  "h6",
  // Sections and headings
  "header",
  // Flow content
  "hgroup",
  // Sections and headings
  "hr",
  // Flow content
  "html",
  // Page
  "legend",
  // Flow content
  "listing",
  // Flow content (legacy)
  "main",
  // Flow content
  "menu",
  // Lists
  "nav",
  // Sections and headings
  "ol",
  // Lists
  "p",
  // Flow content
  "plaintext",
  // Flow content (legacy)
  "pre",
  // Flow content
  "section",
  // Sections and headings
  "ul",
  // Lists
  "xmp"
  // Flow content (legacy)
]);
function w(e, n = {}) {
  const t = "children" in e ? e.children : [], r = v(e), o = H(e, {
    whitespace: n.whitespace || "normal",
    breakBefore: !1,
    breakAfter: !1
  }), i = [];
  (e.type === "text" || e.type === "comment") && i.push(
    ...W(e, {
      whitespace: o,
      breakBefore: !0,
      breakAfter: !0
    })
  );
  let s = -1;
  for (; ++s < t.length; )
    i.push(
      ...R(
        t[s],
        // @ts-expect-error: `tree` is a parent if we’re here.
        e,
        {
          whitespace: o,
          breakBefore: s ? void 0 : r,
          breakAfter: s < t.length - 1 ? x(t[s + 1]) : r
        }
      )
    );
  const c = [];
  let l;
  for (s = -1; ++s < i.length; ) {
    const a = i[s];
    typeof a == "number" ? l !== void 0 && a > l && (l = a) : a && (l !== void 0 && l > -1 && c.push(`
`.repeat(l) || " "), l = -1, c.push(a));
  }
  return c.join("");
}
function R(e, n, t) {
  return e.type === "element" ? te(e, n, t) : e.type === "text" ? t.whitespace === "normal" ? W(e, t) : ne(e) : [];
}
function te(e, n, t) {
  const r = H(e, t), o = e.children || [];
  let i = -1, s = [];
  if (ee(e))
    return s;
  let c, l;
  for (x(e) || B(e) && // @ts-expect-error: something up with types of parents.
  I(n, e, B) ? l = `
` : Z(e) ? (c = 2, l = 2) : v(e) && (c = 1, l = 1); ++i < o.length; )
    s = s.concat(
      R(o[i], e, {
        whitespace: r,
        breakBefore: i ? void 0 : c,
        breakAfter: i < o.length - 1 ? x(o[i + 1]) : l
      })
    );
  return F(e) && // @ts-expect-error: something up with types of parents.
  I(n, e, F) && s.push("	"), c && s.unshift(c), l && s.push(l), s;
}
function W(e, n) {
  const t = String(e.value), r = [], o = [];
  let i = 0;
  for (; i <= t.length; ) {
    O.lastIndex = i;
    const l = O.exec(t), a = l && "index" in l ? l.index : t.length;
    r.push(
      // Any sequence of collapsible spaces and tabs immediately preceding or
      // following a segment break is removed.
      re(
        // […] ignoring bidi formatting characters (characters with the
        // Bidi_Control property [UAX9]: ALM, LTR, RTL, LRE-RLO, LRI-PDI) as if
        // they were not there.
        t.slice(i, a).replace(/[\u061C\u200E\u200F\u202A-\u202E\u2066-\u2069]/g, ""),
        i === 0 ? n.breakBefore : !0,
        a === t.length ? n.breakAfter : !0
      )
    ), i = a + 1;
  }
  let s = -1, c;
  for (; ++s < r.length; )
    r[s].charCodeAt(r[s].length - 1) === 8203 || s < r.length - 1 && r[s + 1].charCodeAt(0) === 8203 ? (o.push(r[s]), c = void 0) : r[s] ? (typeof c == "number" && o.push(c), o.push(r[s]), c = 0) : (s === 0 || s === r.length - 1) && o.push(0);
  return o;
}
function ne(e) {
  return [String(e.value)];
}
function re(e, n, t) {
  const r = [];
  let o = 0, i;
  for (; o < e.length; ) {
    S.lastIndex = o;
    const s = S.exec(e);
    i = s ? s.index : e.length, !o && !i && s && !n && r.push(""), o !== i && r.push(e.slice(o, i)), o = s ? i + s[0].length : i;
  }
  return o !== i && !t && r.push(""), r.join(" ");
}
function H(e, n) {
  if (e.type === "element") {
    const t = e.properties || {};
    switch (e.tagName) {
      case "listing":
      case "plaintext":
      case "xmp":
        return "pre";
      case "nobr":
        return "nowrap";
      case "pre":
        return t.wrap ? "pre-wrap" : "pre";
      case "td":
      case "th":
        return t.noWrap ? "nowrap" : n.whitespace;
      case "textarea":
        return "pre-wrap";
    }
  }
  return n.whitespace;
}
function ie(e) {
  return !!(e.properties || {}).hidden;
}
function oe(e) {
  return e.tagName === "td" || e.tagName === "th";
}
function se(e) {
  return e.tagName === "dialog" && !(e.properties || {}).open;
}
const he = (e = {}) => (n) => new Promise((t) => {
  (async () => {
    var s, c, l;
    const r = [], i = Object.assign({}, {
      theme: "github-dark",
      inlineCode: {
        spaceSubstitution: !1
      }
    }, e);
    P(n, { tagName: "code" }, (a, f) => {
      const u = f.at(-1);
      return (u == null ? void 0 : u.tagName) === "pre" && a.properties.className && (u == null ? void 0 : u.children.length) == 1 && a.properties.className.some((h) => h.startsWith("language-")) ? (r.push({ node: a, ancestors: f, type: "block" }), N) : (
        /** parseInlineCode function extracts the token(language) from the node.
         * It returns an object if it finds a token else it returns the original
         * string
         */
        typeof j(w(a)) != "string" && (u == null ? void 0 : u.tagName) !== "pre" ? (r.push({ node: a, ancestors: f, type: "inline" }), N) : $
      );
    });
    for (const { node: a, ancestors: f } of r.filter(({ type: u }) => u === "block")) {
      const u = f.at(-1), h = f.at(-2), d = (s = f.at(-2)) == null ? void 0 : s.children.findIndex((b) => b === u);
      if (d == null)
        return;
      const m = await E(
        w(a, { whitespace: "pre" }),
        D(a),
        {
          inlineCode: !1,
          theme: i.theme,
          loadThemes: i.loadThemes
        }
      ), y = A(m);
      h == null || h.children.splice(d, 1, C(y));
    }
    for (const { node: a, ancestors: f } of r.filter(({ type: u }) => u === "inline")) {
      const u = ((c = i.inlineCode) == null ? void 0 : c.theme) || i.theme;
      if (!u)
        return;
      const h = f.at(-1), d = h == null ? void 0 : h.children.findIndex((K) => K === a);
      if (d === void 0)
        return;
      const { token: m, content: y } = j(w(a)), b = await E(y, m, {
        inlineCode: !0,
        theme: u,
        loadThemes: i.loadThemes,
        spaceSubstitution: (l = i.inlineCode) == null ? void 0 : l.spaceSubstitution
      }), _ = A(b).childNodes[0].childNodes[0];
      h.children[d] = C(_);
    }
  })().then(() => t());
});
export {
  he as default
};
